# -*- coding: utf-8 -*-

empty_configuration='<kanren_conf><general/><fonts/><strings/></kanren_conf>'
default_configuration='''
    <kanren_conf>
        <general>
            <silentsteps>3</silentsteps>
        </general>
        <fonts>
            <showarea size="56"/>
        </fonts>
        <strings>
        </strings>
    </kanren_conf>
'''

from xml.dom.minidom import parse, parseString

from kanren_log import log

class ConfigXML(object):

    def __init__(self,_filename=None):
        if _filename == None:
            self.conf=parseString(default_configuration)
        elif len(_filename) == 0:
            self.conf=parseString(empty_configuration)
        else:
            # For the time being, it is OK to throw an exception if we have a problem with the file
            self.conf=parse(_filename)    
        self.top=self.conf.documentElement

    def general(self,option):
        pass
        
    def fonts(self,kind,option):
        pass
        
    def strings(self,option):
        pass
        
class ConfigFile(object):

    def __init__(self,_filename=None):
        log("Parsing default configuration")
        self.defconf=ConfigXML()
        if _filename == None:
            log("Parsing empty configuration")
            self.filconf=ConfigXML('')
        else:
            log("::::::: Parsing configuration from",_filename)
            self.filconf=ConfigXML(_filename)        

    def general(self,option):
        result=self.filconf.general(option)
        if result == None:
            result=self.defconf(option)
        return result
        
    def fonts(self,kind,option):
        pass
        
    def strings(self,option):
        pass
        
if __name__ == "__main__":
    cf=ConfigFile()
    
