#!/usr/bin/python
# -*- coding: utf-8 -*-

# Python 2 vs. 3 compatibility imports
try:
    from Tkinter import *
    from tkFont import Font
    from tkMessageBox import showerror
except ImportError:
    from tkinter import *
    from tkinter.font import Font
    from tkinter.messagebox import showerror

import sys
import traceback

from kanren_appstate import *
from kanren_log import *

class Oracle:

    def __init__(self,parent,_settings,_caller):
        self.widget=Frame(parent)
        self.caller=_caller
        self.label=Label(self.widget,text=_settings.oracle_label_text())
        self.is_correct_button=Button(self.widget,text=_settings.ok_label(),command=self.is_correct_command)
        self.is_wrong_button=Button(self.widget,text=_settings.notok_label(),command=self.is_wrong_command)
        self.label.pack()
        self.is_wrong_button.pack(side=RIGHT)
        self.is_correct_button.pack(side=RIGHT)
        
    def is_correct_command(self):
        self.continue_caller(True)
        pass
        
    def is_wrong_command(self):
        self.continue_caller(False)
        pass
        
    def continue_caller(self,_answer_correct_p):
        try:
            self.caller.continue_from_oracle(_answer_correct_p)
        except Exception:
            type_, value_, traceback_ = sys.exc_info()
            fatal(value_)    
            msg=str(value_)
            if is_debug_mode():
                msg=msg+"\n\n"+''.join(traceback.format_exception(type_,value_,traceback_))
            showerror("Exception",msg)

    def show(self):
        self.widget.pack()
       
    def unshow(self):
        self.widget.pack_forget()
        pass
