#!/usr/bin/python
# -*- coding: utf-8 -*-

# Widget like a Label, but the text is not static. It is implemented as a readonly Entry widget.

try:
  from Tkinter import *
  from tkFont import Font
except ImportError:
  from tkinter import *
  from tkinter.font import Font
  
class VarLabel(Entry):
    
    def __init__(self,_parent,initial_text,**keywdargs):
        self.text_v=StringVar()
        Entry.__init__(self,_parent,textvariable=self.text_v,state="readonly",**keywdargs)
        self.settext(initial_text)    
    
    def settext(self,newtext):
        self.text_v.set(newtext)
        self.update_idletasks() # Make text immediately visible
        
    def clear(self):
        self.settext('')
